/*
 * Esercizio 13 Capitolo 6 Savitch.
 * 
 * Scrivere un metodo statico cercaFigura(figura, soglia) dove figura e'
 * un array bidimensionale di valori double. 
 * Il metodo dovrebbe restituire un nuovo array bidimensionale i cui 
 * elementi sono 0.0 o 1.0. Il valore 1.0 indica che il valore corrispondente
 * nell'array figura eccede soglia volte la media di tutti i valori in figura.
 * Gli altri elementi sono a 0.0.
 * Verificare la correttezza con l'esempio mostrato nel testo.
 * 
 */

import java.util.*;

public class CercaFigura{
	
	public static void main(String[] args){
		
		double[][] figura = {{1.2,1.3,4.5,6.0,2.7},{1.7,3.3,4.4,10.5,17.0},{1.1,4.5,2.1,25.3,9.2},{1.0,9.5,8.3,2.9,2.1}};
		
		Scanner tastiera = new Scanner(System.in);
		System.out.print("Inserire il valore della soglia: ");
		double soglia = tastiera.nextDouble();
		
		double[][] nuovaFigura = cercaFigura(figura,soglia);
		
		System.out.println();
		visualizza(nuovaFigura);

		tastiera.close();
	}

	public static double[][] cercaFigura(double[][] figura, double soglia){
		int righe = figura.length;
		int colonne = figura[0].length;
		double[][] nuovo = new double[righe][colonne];
		double media = calcolaMedia(figura);
		for(int i=0; i<righe; i++)
			for (int j=0; j<colonne;j++)
				if(figura[i][j]> soglia*media)
					nuovo[i][j]=1.0;
				else
					nuovo[i][j]=0.0;
		return nuovo;
	}
	
	public static double calcolaMedia(double[][] figura){
		double somma = 0;
		int righe = figura.length;
		int colonne = figura[0].length;
		for(int i=0; i<righe;i++)
			for(int j=0; j<colonne; j++)
				somma += figura[i][j];
		return somma/(righe*colonne);
	}
	
	public static void visualizza(double[][] matrice){
		for(int i=0; i<matrice.length;i++){
			for(int j=0; j<matrice[0].length;j++)
				System.out.print(matrice[i][j]+" ");
			System.out.println();
		}
	}
	
}
